﻿using System;
using System.Reflection;
using System.Reflection.Emit;
using System.Runtime.InteropServices;

namespace ClassLibrary1
{
    [System.Security.SecuritySafeCritical]
    public class Class1
    {
        [DllImport("Win32Project1.dll", EntryPoint = "fnWin32Project1")]
        static extern long GetThisThreadId32();

        static GetThisThreadIdDelegate _GetThisThreadIdMethod = null;
        static object _lockGetThisThraedIdMethod = new object();
        delegate int GetThisThreadIdDelegate();

        public static int GetThisThreadId()
        {
            long result = 0;

            try
            {
                if (_GetThisThreadIdMethod == null)
                {
                    lock (_lockGetThisThraedIdMethod)
                    {
                        if (_GetThisThreadIdMethod == null)
                        {
                            if (IntPtr.Size == 4)
                            {
                                result = GetThisThreadId32();
                            }

                            AssemblyName myAssemblyName = new AssemblyName();
                            myAssemblyName.Name = "EmittedAssembly_" + Guid.NewGuid().ToString();
                            AssemblyBuilder myAssembly = AppDomain.CurrentDomain.DefineDynamicAssembly(myAssemblyName,
                                AssemblyBuilderAccess.Run);

                            ModuleBuilder myModule = myAssembly.DefineDynamicModule("EmittedModule");
                            TypeBuilder helperClass = myModule.DefineType("Helper", TypeAttributes.Public);
                            Type type = helperClass.CreateType();

                            DynamicMethod dynamicMethod = new DynamicMethod("", typeof(int), Type.EmptyTypes, type, true);

                            var iLGenerator = dynamicMethod.GetILGenerator();

                            if (IntPtr.Size == 4)
                            {
                                iLGenerator.Emit(OpCodes.Ldc_I4, (int)result);
                            }
                            else
                            {
                                iLGenerator.Emit(OpCodes.Ldc_I8, result);
                            }

                            iLGenerator.EmitCalli(OpCodes.Calli, CallingConvention.StdCall, typeof(int), Type.EmptyTypes);
                            iLGenerator.Emit(OpCodes.Ret);

                            GetThisThreadIdDelegate tempDelegate = dynamicMethod.CreateDelegate(typeof(GetThisThreadIdDelegate)) as GetThisThreadIdDelegate;
                            _GetThisThreadIdMethod = tempDelegate;
                        }
                    }
                }

                return _GetThisThreadIdMethod();
            }
            catch
            {
            }

            return 0;
        }
    }
}
